unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.ExtCtrls, Vcl.StdCtrls, System.Math,
  Vcl.Buttons, System.UITypes, System.Types;

Type
  TDIarray   = array of array of Double;              // YSH摜pz

type
  TRevarry  = array[0..2] of array[0..4] of double ;  // F␳lz

type
  TForm1 = class(TForm)
    FileOpenbtn: TButton;
    Image1: TImage;
    OpenPictureDialog1: TOpenPictureDialog;
    RGBtoYSHtoRGBBtn: TButton;
    Image2: TImage;
    sat_imageBtn: TButton;
    hue_imageBtn: TButton;
    YmEdit: TLabeledEdit;
    SmEdit: TLabeledEdit;
    HdEdit: TLabeledEdit;
    CheckBox1: TCheckBox;
    yTograyBtn: TButton;
    tran_yshBtn: TBitBtn;
    FileSaveBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    Image3: TImage;
    colorRingBtn: TButton;
    Memo1: TMemo;
    Panel1: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Panel2: TPanel;
    CheckBox7: TCheckBox;
    CheckBox2: TCheckBox;
    procedure FileOpenbtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RGBtoYSHtoRGBBtnClick(Sender: TObject);
    procedure sat_imageBtnClick(Sender: TObject);
    procedure hue_imageBtnClick(Sender: TObject);
    procedure tran_yshBtnClick(Sender: TObject);
    procedure yTograyBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure colorRingBtnClick(Sender: TObject);
    procedure Image3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private 錾 }
    function  sat_image: Integer;               // ʓxf[^ZW摜
    procedure hue_image;                        // Ff[^摜
    procedure tran_ysh(ym, sm, hd :Double);     // Px,ʓx,Fς
    procedure setarray;                         // zTCYݒ
    procedure hue_circle_revision(Mode: integer; rev: TRevarry; Lmode: boolean);  // ␳F}
    procedure Revinitial;                                         // F␳l
    function  RingShift(Hu: double; rev: TRevarry):double;        // F␳
    procedure RevDisp;                                            // F␳l\
    procedure HueMsin(Q :double; I:integer);                      // F␳l͈͐ݒ
    procedure PanelBtnset;                                        // ␳l͑IWI{^ʒuݒ
    function HuRedCalc(Mode: integer): double;                    // PxϊWɂԂ̐FvZ
    procedure rgb_to_ysh;                                         // q,f,aYSH(Px,ʓx,F)ɕϊ
    procedure ysh_to_rgb(hu, sa, yo: TDIarray);                   // YSH q,f,aɕϊ
  public
    { Public 錾 }
  end;

type
  TPrgbarry = array[0..0] of Trgbtriple;                          // rgbz|C^ݒ
  Prgbarry  = ^TPrgbarry;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHW   = 450;                                // \gTCY
  Image3HW  = 300;
  ButtonW   = 105;

  krD = 0.298912;                                 // R PxϊW
  kgD = 0.586611;                                 // G PxϊW
  kbD = 0.114478;                                 // B PxϊW


var
  GHeight, GWidth : integer;                  // 摜TCY
  Vrect           : Trect;
  InBitmap        : TBitmap;                  // ͉摜rbg}bv
  OutBitmap       : TBitmap;                  // o͉摜rbg}bv

  y               : TDIarray;                 // y  Px
  sat             : TDIarray;                 // ʓx
  hue             : TDIarray;                 // F

  Out_y           : TDIarray;                 // y  Px
  Out_sat         : TDIarray;                 // ʓx
  Out_Hue         : TDIarray;                 // F

  kr              : double;                   // = 0.299;  R PxϊW
  kg              : double;                   // = 0.587;  G PxϊW
  kb              : double;                   // = 0.114;  B PxϊW

  revision        : TRevarry;                 // F␳p O

  Drawing       : Boolean;                    // }EXIg\tO
  Origin        : TPoint;                     // }EXX^[gʒu
  EndPoint      : TPoint;                     // }EXAbvʒu
  NewMove       : Boolean;                    // }EXVړ
  REMove        : Boolean;                    // Ęg\

  OriginG       : TPoint;                     // }EXX^[gʒu
  EndPointG     : TPoint;                     // }EXAbvʒu
  GScale        : double;                     // 摜TCYW

//----------------------------------------
// PxϊWɂԂ̐FvZ
// WNTSC @ 113.1
// 120   120
//----------------------------------------
function TForm1.HuRedCalc(Mode: integer): double;
var
  y, cr, cb : double;
begin
  // ϊWݒ
  if Mode = 0 then begin
    // WPxϊW@
    kr := krD;
    kg := kgD;
    kb := kbd;
  end
  else begin
    // 120FpxϊW
    kr := 255 / (255 - 255 * tan(105 / 180 * pi));  // kr = kb = 0.211325
    kb := kr;
    kg := 1 - kr - kb;                              // kg = 0.57735
//    kr := 0.211325;
//    kg := 0.57735;
//    kb := 0.211325;
  end;
  // Ԃ̊pxvZ
  y := kr * 255;
  //  y := kr * r + kg * g + kb * b;
  cr := 255 - y;
  cb := 0 - y;
  result := arctan2(cr, cb) * 180 / pi;
end;

// ------------ Fpx␳ ------------------------
// w肳ꂽ͈͂ƕ␳ʂŐFpx̕␳܂B
// Hu@ Fpx
// rev@␳wz
//---------------------------------------------------
function TForm1.RingShift(Hu: double; rev: TRevarry):double;
var
  J               : integer;
  J0, J1, J2, J3  : double;
  revkU, revkD    : double;
begin
  for J := 0 to 2 do begin
    J0 := rev[J,0];                                 // l
    J1 := rev[J,1];                                 // l
    J2 := rev[J,2];                                 // ړwʒu
    J3 := rev[J,3];                                 // ړ
    if (rev[J,4] <> 0) and (J0 <> J1) then begin  // rev[J,4] CL 1  0  &  <>
      if J1 < J0 then  begin                      // 菬
        if Hu < J1 then Hu := Hu + 360;             // F菬360Z
        if J0 > J2 then J2 := J2 + 360;             // ړwʒu菬360Z
        J1 := J1 + 360;                             // l360Z   Z̏Ԃɒ
      end;
      if (Hu >= J0) and (Hu < J1) then begin      // FƏ̒ɓĂ
        if Hu >= J2 then begin                      // Fړwʒu傫
          revkU := (J1 - (J2 + J3)) / (J1 - J2);    // CW
          Hu   := J1 - (J1 - Hu) * revkU;           // F␳lvZ
        end
        else begin                                  // Fړwʒu菬
          revkD := ((J2 + J3) - J0) / (J2 - J0);    // CW
          Hu   := (Hu - J0) * revkD + J0;           // F␳lvZ
        end;
      end;
    end;
    if hu >= 360 then hu := hu - 360;
    if hu < 0    then hu := hu + 360;
  end;
  result := hu;
end;

//------------ colorring} -------------------------------------
// Mode 0   W@
// Mode 1 @120
// rev      F␳z
// Lmode    False  ␳FRing  True ␳OFRing
// HSV@\Ȃ̂ŐF͔v
//----------------------------------------------------------------
procedure TForm1.hue_circle_revision(Mode: integer; rev: TRevarry; Lmode: boolean);
var
  i  : integer;
  hu, huRed : double;
  st : double;
  y, cb, cr     : double;
  fr, fg, fb    : double;
  kbg, krg      : double;
  r, g, b       : byte;
  max, min, ks  : double;
  N             : integer;
  huD, hub      : double;
  q1, q2        : integer;
  q1p, q2p      : double;
  RO, RI, RF    : integer;
begin
  if Lmode then begin         // ␳\
    q1 := 4;
    q2 := q1 div 2 - 1;
    RO  := 95;
    RI  := 85;
  end
  else begin                  // ʏ\
    q1 := 8;
    q2 := q1 div 2 - 2;
    RO  := 80;
    RI  := 60;
  end;
  RF  := (RO + RI) div 2;
  q1p := q1 / 180 * pi;
  q2p := q2 / 180 * pi;
  // ϊWݒ
  huRed := HuRedCalc(Mode);
  // tϊWvZ
  kbg := kb / kg;
  krg := kr / kg;
  // ʓxl
  st := 255;
  // Pxl
  y := 255;
  // vZ
  N := 360 div q1 - 1;
  with Image3.canvas do begin
   // C[W
    if not Lmode then begin
      Brush.Style := bsSolid;
      Brush.Color := clBlack;
      FillRect(Rect(0, 0, Width, Height));                          // Canvas 摜
      Pen.Width :=2;
    end
    else
      Pen.Width := 4;
    // F}
    for i := 0 to N do begin
      hub := i * q1;
      // F␳\w͈̓Vtg
      if Lmode then begin
        // F␳
        huD := RingShift(hub, rev);
        // Fl\
        memo1.Lines.Add(floatTostr(hub) + '  ' + floatTostr(huD));
      end
      else huD := hub;
      // Fpx  Ԃ[xɐݒ@Cɕ`悷
      // Ԃ^ɂȂ܂
      // WŃ[ẍʒuԂɂ܂B
      huD := huD + huRed;
      if huD > 0 then huD := huD - 360;
      hu := huD / 180 * pi;
      // FW B - Y
      cb := st * cos(hu);
      // FW R - Y
      cr := st * sin(hu);
      // R G B  ̒lvZ
      fr := y + cr;
      fg := y - kbg * cb - krg * cr;
      fb := y + cb;
      // őlŏl
      max := fr;
      min := fr;
      if fg > max then max := fg;
      if fb > max then max := fb;
      if fg < min then min := fg;
      if fb < min then min := fb;
      // R G B ̒lC
      ks := 255 / (max - min);
      r := round((fr - min) * ks);
      g := round((fg - min) * ks);
      b := round((fb - min) * ks);
      // `Fݒ
      Pen.Color := rgb(r, g, b);
      brush.Color := rgb(r, g, b);
      // F`
      Moveto(150 + round(RI * cos(i * q1p - q2p)),150 - round(RI * sin(i * q1p - q2p)));
      Lineto(150 + round(RO * cos(i * q1p - q2p)),150 - round(RO * sin(i * q1p - q2p)));
      AngleArc(150, 150, RO, i* q1 - q2, q2 * 2);

      Moveto(150 + round(RI * cos(i * q1p - q2p)),150 - round(RI * sin(i * q1p - q2p)));
      AngleArc(150, 150, RI,i* q1 - q2, q2 * 2);
      Lineto(150 + round(RO * cos(i * q1p + q2p)),150 - round(RO * sin(i * q1p + q2p)));
      // hԂ
      if not Lmode then
        floodfill(150 + round(RF * cos(i * q1p)),150 - round(RF * sin(i * q1p)),rgb(r, g, b),fsBorder);
    end;
    if Lmode then begin
      font.Height := 18;
      brush.Color := clblack;
      font.Color  := clWhite;
      textout(150 + 105, 150 -   8, '0');
      textout(150 -  10, 150 - 120, '90');
      textout(150 - 140, 150 -   8, '180');
      textout(150 -  10, 150 + 100, '270');
    end;
  end;
end;

//----------------------------
// FpҏWl̓͗L
//-----------------------------
procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  if checkbox1.Checked then begin
    hue_circle_revision(1, revision, false);
    hue_circle_revision(1, revision, true);
  end
  else begin
    hue_circle_revision(0, revision, false);
    hue_circle_revision(0, revision, true);
  end;
  RevDisp;    // F␳l̕\
end;

//---------------------------------
// ݒP̗L
//---------------------------------
procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  RevDisp;    // F␳l̕\
end;

//---------------------------------
// ݒQ̗L
//---------------------------------
procedure TForm1.CheckBox5Click(Sender: TObject);
begin
  RevDisp;    // F␳l̕\
end;

//---------------------------------
// ݒR̗L
//---------------------------------
procedure TForm1.CheckBox6Click(Sender: TObject);
begin
  RevDisp;    // F␳l̕\
end;

//---------------------------------
// F␳l̕\
//---------------------------------
procedure TForm1.RevDisp;
var
  I : integer;
  Max, Cen : double;
begin
  memo1.Clear;
  if checkBox4.Checked then revision[0, 4] := 1
                       else revision[0, 4] := 0;
  if checkBox5.Checked then revision[1, 4] := 1
                       else revision[1, 4] := 0;
  if checkBox6.Checked then revision[2, 4] := 1
                       else revision[2, 4] := 0;
  for I := 0 to 2 do begin
    Memo1.Lines.Add('ݒ@@@' + inttostr(I + 1));
    Memo1.Lines.Add('@l@@' + floattostr(revision[I, 0]));
    Memo1.Lines.Add('@l@@' + floattostr(revision[I, 1]));
    Memo1.Lines.Add('@wʒu@' + floattostr(revision[I, 2]));
    Memo1.Lines.Add('@ړʁ@@' + floattostr(revision[I, 3]));
    if revision[I,4] <> 0 then Memo1.Lines.Add('@L@@@' + floattostr(revision[I, 4]))
                          else Memo1.Lines.Add('@@@@' + floattostr(revision[I, 4]));
    Memo1.Lines.Add(' ');
  end;
    Memo1.Lines.Add(' ');
  for I := 0 to 2 do begin
    Max := revision[I, 1];                            // l
    Cen := revision[I, 2];                            // wʒu
    if revision[I, 0] > revision[I, 1] then begin     // ll傫
      Max := Max + 360;                                 // l360Z
      if revision[I, 2] < revision[I, 0] then           // wll菬wl360Z
        Cen := revision[I, 2] + 360;
    end;
    if revision[i, 3] >= 0 then begin                 // ړʂvX`FbN
      if MAX <= Cen + revision[I, 3] then               // wʒuvXړʂl𒴂
        Memo1.Lines.Add('ݒ' + intTostr(I + 1) + 'C͈̔͂l𒴂Ă܂B');
    end
    else begin                                        // ړʂ}CiX
      if revision[I, 0] >= Cen + revision[I, 3] then  // wʒuvXړʂl𒴂
        Memo1.Lines.Add('ݒ' + intTostr(I + 1) + 'C͈̔͂l𒴂Ă܂B');
    end;
    if (Max < Cen) or (revision[I, 0] > Cen) then
        Memo1.Lines.Add('ݒ' + intTostr(I + 1) + 'wʒu㉺͈̔͂𒴂Ă܂B');
  end;
end;

//---------------------------------
// ␳z񏉊ݒ
//---------------------------------
procedure TForm1.Revinitial;
begin
  revision[ 0, 0] := 315;    // ̒l
  revision[ 0, 1] :=  90;    // ̒l
  revision[ 0, 2] :=  20;    // ␳ʒu
  revision[ 0, 3] :=  20;    // ␳
  revision[ 0, 4] :=  0;     // L

  revision[ 1, 0] := 197;    // ̒l
  revision[ 1, 1] := 330;    // ̒l
  revision[ 1, 2] := 217;    // ␳ʒu
  revision[ 1, 3] :=  30;    // ␳
  revision[ 1, 4] :=   1;    // L

  revision[ 2, 0] := 110;    // ̒l
  revision[ 2, 1] := 220;    // ̒l
  revision[ 2, 2] := 170;    // ␳ʒu
  revision[ 2, 3] := -30;    // ␳
  revision[ 2, 4] :=  0;     // L
  if revision[0, 4] = 1 then checkBox4.Checked := true;
  if revision[1, 4] = 1 then checkBox5.Checked := true;
  if revision[2, 4] = 1 then checkBox6.Checked := true;
  RevDisp;                    // F␳l̕\
end;

//-----------------------------------------------------
// F\ 1  W     @113.1,225,352.7
//@          0  120  105  ,225,345
//-----------------------------------------------------
procedure TForm1.colorRingBtnClick(Sender: TObject);
begin
  colorRingBtn.Enabled := False;
  memo1.Clear;
  if checkbox1.Checked then begin
    hue_circle_revision(1, revision, false);
    hue_circle_revision(1, revision, true);
  end
  else begin
    hue_circle_revision(0, revision, false);
    hue_circle_revision(0, revision, true);
  end;
  checkBox3.Checked := False;
  colorRingBtn.Enabled := True;
end;

//--- tran_ysh  Px,ʓx,Fς܂ ---------------
//    y:            ̓f[^z@x
//    sat:          ̓f[^z@r`s
//    hue:          ̓f[^z@gtd
//    out_y:        o̓f[^z@x
//    out_sat:      o̓f[^z@r`s
//    out_hue:      o̓f[^z@gtd
//    ym:           Px̏搔
//    sm:           ʓx̏搔
//    hd:           F̑
//------------------------------------------------------
procedure TForm1.tran_ysh(ym, sm, hd :Double);
var
  i, j  : integer;
  hub   : double;
  revi  : TRevarry;                          // F␳p O
  huRed : double;
begin
  // `FbN PxϊWFpx120xɂȂ悤ɐݒ R 105x g 225x b 345x
  // `FbN  @@@@@@@@@@@@@@@@@@@@@@ R 113x g 225x b 353x
  if checkbox1.Checked then huRed := HuRedCalc(1)
                       else huRed := HuRedCalc(0);
  for i := 0 to 2 do                         // O
    for j := 0 to 4 do begin                 // ܍
      if j <= 2  then begin
        // YSH̐Ԃ̐Fʒuƕ␳l̐Ԃ̈ʒuႤ̂ŕ␳lC܂
        revi[i, j] := revision[i][j] + huRed;
        if revi[i, j] >= 360 then revi[i, j] := revi[i][j] - 360;
      end
      else revi[i, j] := revision[i, j]
    end;
  // PxAʓxAF̕␳vZ
  for i := 0 to GHeight - 1 do
    for j := 0 to GWidth - 1 do begin
      out_y[i][j]   := y[i][j] * ym;                        // Px̌vZ
      out_sat[i][j] := sat[i][j] * sm;                      // ʓx̌vZ
      // F␳vZ̑I
      if not checkBox2.Checked then begin                 // S̕␳
        hub := hue[i][j] + hd;                              // F̌vZ
        if hub >= 360 then hub := hub - 360;
        if hub <  0   then hub := hub + 360;
        out_hue[i][j] := hub;
      end
      else begin                                          // ␳
        if CheckBox7.Enabled then begin                       // ͈͎w肾
          if not CheckBox7.Checked then begin                 // w͈͓␳
            if (j >= OriginG.X) and (j <= EndPointG.X)
              and (i >= OriginG.Y) and (i <= EndPointG.Y) then
                out_hue[i][j] := RingShift(hue[i][j], revi)   // ␳zɂFC
            else out_hue[i][j] := hue[i][j];
          end
          else                                                // w͈͊O␳
            if (j >= OriginG.X) and (j <= EndPointG.X)
              and (i >= OriginG.Y) and (i <= EndPointG.Y) then
                out_hue[i][j] := hue[i][j]
              else
                out_hue[i][j] := RingShift(hue[i][j], revi);   // ␳zɂFC
        end
        else
          out_hue[i][j]:= RingShift(hue[i][j], revi);   // ␳zɂFC
      end;
    end;
  ysh_to_rgb(out_hue, out_sat, out_y);
  Image2.Canvas.StretchDraw(VRect, OutBitmap);        // o͘gɕϔ{o
end;

//------------- PxAʓxAFς܂ -----------------
//    ym:           Px̏搔
//    sm:           ʓx̏搔
//    hd:           F̑
//--------------------------------------------------------
procedure TForm1.tran_yshBtnClick(Sender: TObject);
var
  ym    : Double;
  sm    : Double;
  hd    : Double;
  ch    : Integer;
begin
  CheckBox3.Checked := False;
  tran_yshBtn.Enabled := False;
  // `FbN PxϊWFpx120xɂȂ悤ɐݒ R 105x g 225x b 345x
  // `FbN  @@@@@@@@@@@@@@@@@@@@@@ R 113x g 225x b 353x
  if CheckBox1.Checked then huRedCalc(1)     // 105
                       else huRedCalc(0);    // 113
  setarray;                       // zTCYݒ
  rgb_to_ysh;
  val(ymEdit.Text, ym, ch);       // Px̏搔
  if ch <> 0 then ym := 1;
  ym := abs(ym);
  val(smEdit.Text, sm, ch);       // ʓx̏搔
  if ch <> 0 then sm := 1;
  sm := abs(sm);
  val(hdEdit.Text, hd, ch);       // F̑
  if ch <> 0 then hd := 0;
  if hd > 360  then hd :=  360;   // 360xȓɐݒ
  if hd < -360 then hd := -360;
  tran_ysh(ym, sm, hd);           // Px,ʓx,Fς
  filesavebtn.Enabled := True;
  tran_yshBtn.Enabled := True;
end;

//--- hue_image  Ff[^摜܂ ---------------------
//    sat:          ʓx̃f[^z
//    hue:          F̃f[^z
//    stdhue:       ƂȂFl
//    OutBitmap:    o͉摜
//-------------------------------------------------------------
procedure TForm1.hue_image;
var
  i, j    : Integer;
  ihue    : Integer;
  delt    : Double;
  OutPrgbarray  : Prgbarry;
  stdhue  : double;
begin
  val(hdedit.Text, stdhue, i);
  if i <> 0 then stdhue := 0;
  if stdhue > 360  then stdhue :=  360;                       // 360xȓɐݒ
  if stdhue < -360 then stdhue := -360;
  for i := 0 to GHeight - 1 do begin
    OutPrgbarray := OutBitmap.ScanLine[i];
    for j := 0 to GWidth - 1 do begin
      if sat[i][j] > 0 then begin                             // ʓx[ȏゾ
        delt := abs(hue[i][j] - stdhue);                      // Fpx̐Βl
        if delt < 0 then delt := delt + 360;
        if delt > 180  then delt := 360.0 - delt;             // 180xȓɐݒ@
        ihue := Trunc(255.0 - delt * 255.0 / 180);            // 2550ɕϊ
        OutPrgbarray[j].rgbtBlue  := ihue;
        OutPrgbarray[j].rgbtGreen := ihue;
        OutPrgbarray[j].rgbtRed   := ihue;
      end
      else begin
        OutPrgbarray[j].rgbtBlue  := 0;
        OutPrgbarray[j].rgbtGreen := 0;
        OutPrgbarray[j].rgbtRed   := 0;
      end;
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
end;

//-----------------------------------------
// Fp̃f[^[摜\
//-----------------------------------------
procedure TForm1.hue_imageBtnClick(Sender: TObject);
begin
  hue_image;        // Ff[^摜
end;

//------------------------------
// F␳l͈͐ݒ
//------------------------------
procedure TForm1.HueMsin(Q :double; I:integer);
begin
  if revision[ I, 0] < revision[ I, 1]  then begin
    revision[ I, 3] := Q - revision[ I, 2];
  end
  else begin
    if Q < revision[ I, 1] then begin
      if revision[ I, 2] < revision[ I, 1] then
        revision[ I, 3] := Q -  revision[ I, 2];
      if revision[ I, 2] > revision[ I, 0] then
        revision[ I, 3] := Q +  (360 - revision[ I, 2]);
    end;
    if Q > revision[ I, 0] then begin
      if revision[ I, 2] > revision[ I, 0] then
        revision[ I, 3] := Q -  revision[ I, 2];
      if revision[ I, 2] < revision[ I, 1] then
        revision[ I, 3] := - (revision[ I, 2] + 360 - Q);
    end;
  end;
end;

//----------------------------------------------
// ͉摜Ń}EXɂF␳͈͎w
//----------------------------------------------
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  if REMove then begin                                                    // ͈͎w肪
    Image1.Canvas.Pen.Mode := pmNotXor;                                   // y[h Not Xor
    Image1.Canvas.Rectangle(Origin.X, Origin.Y, EndPoint.X, EndPoint.Y);  // O̐
    REMove := False                                                       // ͈͎w
  end;
  Origin := Point(X, Y);                                                  // W̕ۑ
  EndPoint := point(X, Y);                                                // VWۑ
  NewMove := True;                                                        // VKړ
  Drawing := True;                                                        // g`撆Zbg
  Image1.Canvas.Pen.Mode := pmCopy;                                       // y[hʏ
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if Drawing and (Shift = [ssLeft]) then begin        // g`撆ō{^Ȃړ
    Image1.Canvas.Pen.Mode := pmNotXor;                                     // y[h Not Xor
    if not NewMove then begin                         // ړȂ
      Image1.Canvas.Rectangle(Origin.X, Origin.Y, EndPoint.X, EndPoint.Y);  // O̐
    end;
    EndPoint := point(X, Y);                                                // VWۑ
    Image1.Canvas.Rectangle(Origin.X, Origin.Y, EndPoint.X, EndPoint.Y);
    NewMove := False;                                                       // VKړZbg
    Image1.Canvas.Pen.Mode := pmCopy;                                       // y[hʏ
  end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  OX, EX : integer;
  OY, EY : integer;
begin
  if Drawing then begin           // g`撆Ȃ
    REMove := True;                 // ͈͎wZbg
    Drawing := False;               // g`撆Zbg
    NewMove := False;               // VKړZbg
    OX := Origin.X;
    OY := Origin.Y;
    EX := EndPoint.X;
    EY := EndPoint.Y;
    // w͈͍W̐
    if OX > EX then begin
      Origin.X := EX;
      EndPoint.X := OX;
    end;
    if OY > EY then begin
      Origin.Y := EY;
      EndPoint.Y := OY;
    end;
    // ͈͂[Ȃ͈͎w
    if (OX = EX) and (OY = EY) then begin
      CheckBox7.Enabled := False;   // ͈͎w@`FbN{bNX fXGu
      REMove := False;              // ͈͎wtOZbg
    end
    else
      CheckBox7.Enabled := True;    // ͈͎w@`FbN{bNX Cl[u
    // w͈͍W摜Wɕϊ
    OriginG.X := round(Origin.X * Gscale);
    OriginG.Y := round(Origin.Y * Gscale);
    EndPointG.X := round(EndPoint.X * Gscale);
    EndPointG.Y := round(EndPoint.Y * Gscale);
  end;
end;

//----------------------------------------------
// F\̃}EẌʒuFҏWl
//----------------------------------------------
procedure TForm1.Image3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Xpos, Ypos : integer;
  Q          : double;
begin
  if not CheckBox3.Checked then exit;
  Xpos := X - 150;
  Ypos := 150 - Y;
  Q := arctan2(Ypos, Xpos);
  Q := int(Q / Pi * 180);
  if Q < 0 then Q := Q + 360;
  if RadioButton1.Checked then revision[ 0, 0] := Q;
  if RadioButton2.Checked then revision[ 0, 1] := Q;
  if RadioButton3.Checked then revision[ 0, 2] := Q;
  if RadioButton4.Checked then begin
    HueMsin(Q, 0);
  end;
  if RadioButton5.Checked then revision[ 1, 0] := Q;
  if RadioButton6.Checked then revision[ 1, 1] := Q;
  if RadioButton7.Checked then revision[ 1, 2] := Q;
  if RadioButton8.Checked then begin
    HueMsin(Q, 1);
  end;
  if RadioButton9.Checked then revision[ 2, 0] := Q;
  if RadioButton10.Checked then revision[ 2, 1] := Q;
  if RadioButton11.Checked then revision[ 2, 2] := Q;
  if RadioButton12.Checked then begin
    HueMsin(Q, 2);
  end;
  RevDisp;                // F␳l̕\
end;

//--- sat_image  ʓxf[^ZW摜܂ ----------------------------
//    sat:          ʓx̃f[^z
//    OutBitmap:    o͉摜
//------------------------------------------------------------------------
function TForm1.sat_image: Integer;
var
  i, j      : Integer;
  isat      : Integer;
  min, max  : double;
  OutPrgbarray  : Prgbarry;
begin
  min := 255;
  max := 0;
  // ʓx̍őlƍŏl
  for i := 0 to  GHeight - 1 do
    for j := 0 to GWidth - 1 do begin
      if sat[i][j] > max then max := sat[i][j];
      if sat[i][j] < min then min := sat[i][j];
    end;
  // ʓxȂI
  if min = max then begin
    result := -1;
    exit;
  end;
  for i := 0 to GHeight - 1 do begin
    OutPrgbarray := OutBitmap.ScanLine[i];
    for j := 0 to GWidth - 1 do begin
      isat := Trunc(255 * (sat[i][j] - min) / (max - min));   // ʓx̒l0`255ɕϊ
      OutPrgbarray[j].rgbtRed   := isat;
      OutPrgbarray[j].rgbtGreen := isat;
      OutPrgbarray[j].rgbtBlue  := isat;
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
  result := 0;
end;

//---------------------------------------------
// ʓxf[^[̉摜\
//---------------------------------------------
procedure TForm1.sat_imageBtnClick(Sender: TObject);
var
  Ret : Integer;
begin
  Ret := sat_image;                                           // ʓxf[^ZW摜
  if Ret = -1 then application.MessageBox('ʓx܂B','',0);
end;

// OC摜(Px)\
procedure TForm1.yTograyBtnClick(Sender: TObject);
var
  i, j          : Integer;
  iglay         : Integer;
  OutPrgbarray  : Prgbarry;
begin
  for i := 0 to GHeight - 1 do begin
    OutPrgbarray := OutBitmap.ScanLine[i];
    for j := 0 to GWidth - 1 do begin
      iglay := round(y[i,j]);
      OutPrgbarray[j].rgbtRed   := iglay;
      OutPrgbarray[j].rgbtGreen := iglay;
      OutPrgbarray[j].rgbtBlue  := iglay;
    end;
  end;
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
end;

//---------------------------------------------
// PxAʓxAF  qfaɕϊ܂
// hu     Fz
// sa     ʓxz
// yo     Pxz
//---------------------------------------------
procedure TForm1.ysh_to_rgb(hu, sa, yo: TDIarray);  // YSH q,f,aɕϊ
var
  i, j        : Integer;
  rad, c1, c2 : Double;
  ir, ig, ib    : Integer;
  OutPrgbarray  : Prgbarry;
  a, b          : Double;
begin
  a := kr / kg;                                            // a = 0.299 / 0.587
  b := kb / kg;                                            // b = 0.114 / 0.587
  for i := 0 to GHeight - 1 do begin
    OutPrgbarray := OutBitmap.ScanLine[i];
    for j := 0 to GWidth - 1 do begin
      rad := PI * hu[i][j] / 180;
      c1 := sa[i][j] * sin(rad);
      c2 := sa[i][j] * cos(rad);
      ir := Trunc(yo[i][j] + c1);                    // R = Y + (R - Y)
      if ir > 255 then ir := 255;
      if ir < 0   then ir := 0;
      ig := Trunc(yo[i][j] - a * c1 - b * c2);       // G = Y - a(R - Y) - b(B - Y)
      if ig > 255 then ig := 255;
      if ig < 0   then ig := 0;
      ib := Trunc(yo[i][j] + c2);                    // B = Y + (B - Y)
      if ib > 255 then ib := 255;
      if ib < 0   then ib := 0;
      OutPrgbarray[j].rgbtRed   := ir;
      OutPrgbarray[j].rgbtGreen := ig;
      OutPrgbarray[j].rgbtBlue  := ib;
    end;
  end;
end;

//----------------------------------------------------
// qfa PxvalueAʓxsatAFhueɕύX܂B
//----------------------------------------------------
procedure TForm1.rgb_to_ysh;                        // q,f,aPx,ʓx,Fϊ
var
  i, j        : Integer;
  fr, fg, fb  : Double;
  c1, c2      : Double;
  Inprgbarry  : Prgbarry;                               // rgbz|C^
begin
  for i := 0 to GHeight - 1 do begin
    Inprgbarry := inBitmap.ScanLine[i];
    for j := 0 to GWidth - 1 do begin
      fr := Inprgbarry[j].rgbtRed;
      fg := Inprgbarry[j].rgbtGreen;
      fb := Inprgbarry[j].rgbtBlue;
      y[i][j]  :=  kr * fr + kg * fg + kb * fb;         // Y                Px
      c1 :=  fr - y[i][j];                              // R - Y  (fr - y)  FC1
      c2 :=  fb - y[i][j];                              // B - Y  (fb - y)  FC2
      sat[i][j] := sqrt(c1 * c1 + c2 * c2);             // ʓx
      hue[i][j] := arctan2(c1, c2) * 180 / pi;          // F
      if hue[i][j] < 0 then  hue[i][j] := hue[i][j] + 360;
    end;
  end;
end;

//---------- z̒Zbg---------------------
//    y:            f[^z@x
//    sat:          ʓx̃f[^z
//    hue:          F̃f[^z
//    out_y         o͋Px̃f[^z
//    out_sat:      o͍ʓx̃f[^z
//    out_hue:      o͐F̃f[^z
//------------------------------------------------
procedure TForm1.setarray;
begin
  setlength(y,   GHeight, GWidth);
  setlength(sat, GHeight, GWidth);
  setlength(hue, GHeight, GWidth);
  setlength(out_sat, GHeight, GWidth);
  setlength(out_hue, GHeight, GWidth);
  setlength(out_y,   GHeight, GWidth);
  OutBitmap.Width  := GWidth;
  OutBitmap.Height := GHeight;
end;

//------- eϊ㌳֖߂ĉ摜\mF--------------------
procedure TForm1.RGBtoYSHtoRGBBtnClick(Sender: TObject);
begin
  // `FbN PxϊWFpx120xɂȂ悤ɐݒ R 105x g 225x b 345x
  // `FbN  @@@@@@@@@@@@@@@@@@@@@@ R 113x g 225x b 353x
  if CheckBox1.Checked then huRedCalc(1)     // 105
                       else huRedCalc(0);    // 113
  setarray;                                                   // zTCYݒ
  rgb_to_ysh;
  ysh_to_rgb(hue, sat, y);
  Image2.Canvas.StretchDraw(VRect, OutBitmap);                // o͘gɕϔ{o
  sat_imageBtn.Enabled  := True;
  hue_imageBtn.Enabled  := True;
  yTograyBtn.Enabled    := True;
end;

//------- 摜t@CI[v \---------------------------
procedure TForm1.FileOpenbtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  InFilename  : String;
  IHeight     : Integer;
  IWidth      : Integer;
begin
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  Image2.Canvas.Brush.Style := bsSolid;
  Image2.Canvas.Brush.Color := clBtnface;
  Image2.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        IWidth  := ImageHW;                                   // o͐C[W1̕
        IHeight := ImageHW;                                   // o͐C[W1̍
        if GHeight <= GWidth then                             // cɂo̓TCYݒ
          IHeight := Round(IWidth * GHeight / GWidth)
        else
          IWidth := Round(IHeight * GWidth / GHeight);
        Image1.Width := IWidth;
        Image1.Height:= IHeight;
        Image1.Picture.Bitmap.SetSize(IWidth, IHeight);
        VRect := Rect(0, 0, IWidth, IHeight);                 // o͘gݒ
        Image1.Canvas.StretchDraw(VRect, WIC);                // o͘gɕϔ{o
        InBitmap.Width  := GWidth;
        InBitmap.Height := GHeight;
        InBitmap.Canvas.Draw(0, 0, WIC);                      // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  GScale := GWidth / Image1.Width;
  REMove := False;
  CheckBox7.Enabled := False;
  RGBtoYSHtoRGBBtn.Enabled    := True;
  sat_imageBtn.Enabled  := False;
  hue_imageBtn.Enabled  := False;
  tran_yshBtn.Enabled   := True;
end;

//--------- t@C֕ۑ -----------------
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                             // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                 // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                               // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');    // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                          // gqo
  if not WFormatSet then begin                                              // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                       // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                           // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                 // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                  // TWicImage
  try
    WIC.Assign(OutBitmap);                                                  // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                                // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                  // t@C̏o
  finally                                                                   // XE3,XE4̏ꍇ̓AV[v}XLOQƂĂ
    WIC.Free;                                                               // TWicImage
  end;
end;

//----------- ݒ ---------------
// ␳lIWI{^̐ݒ
//------------------------------------
procedure TForm1.PanelBtnset;
const
  Btnp = 20;
var
  I : integer;
begin
  for I := 1 to 12 do begin
    TRadioButton(FindComponent('RadioButton' + IntToStr(I))).Height := 15;
    TRadioButton(FindComponent('RadioButton' + IntToStr(I))).Width := 100;
    TRadioButton(FindComponent('RadioButton' + IntToStr(I))).Left := 16;
  end;
  checkBox3.Height := 15;
  checkBox3.Width := 100;
  checkBox3.Top := 5;
  checkBox3.left := 5;

  checkBox4.Height := 15;
  checkBox4.Width := 100;
  checkBox4.Left := 10;
  checkBox5.Height := 15;
  checkBox5.Width := 100;
  checkBox5.Left := 10;
  checkBox6.Height := 15;
  checkBox6.Width := 100;
  checkBox6.Left := 10;

  RadioButton1.Top := checkBox3.Top + Btnp + 5;
  RadioButton2.Top := RadioButton1.Top + Btnp;
  RadioButton3.Top := RadioButton2.Top + Btnp;
  RadioButton4.Top := RadioButton3.Top + Btnp;
  checkBox4.Top := RadioButton4.Top + Btnp;

  RadioButton5.Top := checkBox4.Top + Btnp + 20;
  RadioButton6.Top := RadioButton5.Top + Btnp;
  RadioButton7.Top := RadioButton6.Top + Btnp;
  RadioButton8.Top := RadioButton7.Top + Btnp;
  checkBox5.Top := RadioButton8.Top + Btnp;

  RadioButton9.Top := checkBox5.Top + Btnp + 20;
  RadioButton10.Top := RadioButton9.Top + Btnp;
  RadioButton11.Top := RadioButton10.Top + Btnp;
  RadioButton12.Top := RadioButton11.Top + Btnp;
  checkBox6.Top := RadioButton12.Top + Btnp;
  panel1.Height := 5 + checkBox6.Top + checkBox6.Height + 5;
end;

//----------------------------------
// Form̐ݒ
//----------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var
  bitmap : Tbitmap;
begin
  Form1.ClientHeight := ImageHW * 2 + 40;
  Form1.ClientWidth := 20 + ImageHW + 20 + Image3HW + 20 + ButtonW + 20;
  Image1.Width  := ImageHW;
  Image1.Height := ImageHW;
  Image2.Width  := ImageHW;
  Image2.Height := ImageHW;
  Image3.Width  := Image3HW;
  Image3.Height := Image3HW;
  bitmap := Tbitmap.Create;
  bitmap.Width := ImageHW;
  bitmap.Height := ImageHW;
  Image1.Picture.Graphic := bitmap;
  Image2.Picture.Graphic := bitmap;
  bitmap.Width := Image3HW;
  bitmap.Height := Image3HW;
  Image3.Picture.Graphic := bitmap;
  Image1.Left   := 20;
  Image2.Left   := 20;
  Image3.Left   := 20 + ImageHW + 20;
  memo1.Width := Image3HW div 2 + 20;
  memo1.Left := 20 + ImageHW + 20;
  panel1.Left := memo1.Left + memo1.Width + 10;
  Image1.Top := 10;
  Image2.Top := 10 + Image2.Height + 20;
  FileOpenBtn.Left := 20 + ImageHW + 20 + Image3HW + 20;
  RGBtoYSHtoRGBbtn.Left := 20 + ImageHW + 20 + Image3HW + 20;
  sat_imageBtn.Left := 20 + ImageHW + 20 + Image3HW + 20;
  hue_imageBtn.Left := 20 + ImageHW + 20 + Image3HW + 20;
  YmEdit.Left := 20 + ImageHW + 20 + Image3HW + 20;
  SmEdit.Left := 20 + ImageHW + 20 + Image3HW + 20;
  HdEdit.Left := 20 + ImageHW + 20 + Image3HW + 20;
  Panel2.Left := 20 + ImageHW + 20 + Image3HW + 15;
  CheckBox1.Left := 20 + ImageHW + 20 + Image3HW + 20;
  CheckBox2.Left := 5;
  CheckBox7.Left := 5;
  yTograyBtn.Left := 20 + ImageHW + 20 + Image3HW + 20;
  tran_yshBtn.Left := 20 + ImageHW + 20 + Image3HW + 20;
  FileSaveBtn.Left := 20 + ImageHW + 20 + Image3HW + 20;
  colorRingBtn.Left := 20 + ImageHW + 20 + Image3HW + 20;
  InBitmap  := TBitmap.Create;
  OutBitmap := TBitmap.Create;
  InBitmap.PixelFormat  := pf24bit;
  OutBitmap.PixelFormat := pf24bit;
  RGBtoYSHtoRGBBtn.Enabled    := False;
  sat_imageBtn.Enabled  := False;
  hue_imageBtn.Enabled  := False;
  tran_yshBtn.Enabled   := False;
  yTograyBtn.Enabled    := False;
  filesavebtn.Enabled   := False;
  CheckBox7.Enabled := False;
  GScale := 1;
  memo1.Clear;
  Revinitial;
  tran_yshBtn.Caption := 'Color' + #13#10 + 'YSH to RGB';
  panel1.Caption := '';
  Form1.Caption := 'Y(Px)@S(ʓx)@H(F)@ɂF̒';
  Form1.Top := (screen.Height - Form1.Height) div 2;
  Form1.Left := (screen.Width - Form1.Width) div 2;
  PanelBtnset;
  Drawing := False;
  REMove  := False;
  bitmap.Free;
end;

//------------ I ------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  OutBitmap.Free;
end;

end.
